## squeak-vm 3.7.7

=== platforms/unix/npsqueak/Makefile ===
# Netscape Plugin for Squeak on Unix platforms
# Author: Bert Freudenberg
# Last edited: 2005-02-28 16:57:51 by jens on impara.de

############ Customize flags here #######################

INC	= -I./include -I/usr/X11R6/include
CC	= gcc
CFLAGS	= $(INC) -O2 -fPIC -Wall
LD	= gcc
LDFLAGS = -shared

# usually overridden from top level makefile
VM_VERSION=  3.7b-5
bindir=	     /usr/local/bin
imgdir=	     /usr/local/share/squeak
plgdir=	     /usr/local/lib/squeak/$(VM_VERSION)

# configuration
scriptdir=	$(imgdir)
npsqueakrun=	npsqueakrun


############ compile and link ###########################
all: npsqueak.so npsqueakrun

npsqueak.so : npsqueak.o npunix.o 
	$(LD) $(LDFLAGS) npsqueak.o npunix.o -o npsqueak.so 

npsqueak.o: npsqueak.c ../config.h
	$(CC) -c $(CFLAGS) \
		-DSYSTEM_BIN_DIR=\"$(scriptdir)\" \
		-DSYSTEM_IMG_DIR=\"$(imgdir)\" \
		-DNPSQUEAKRUN=\"$(npsqueakrun)\" $<

npunix.o: npunix.c
	$(CC) -c $(CFLAGS) $<

npsqueakrun: npsqueakrun.in 
	sed "s|@imgdir@|$(imgdir)|; \
	     s|@VM_VERSION@|$(VM_VERSION)|" \
		npsqueakrun.in > $@
	chmod +x $@

npsqueakregister: npsqueakregister.in 
	sed "s|@NPSQUEAK_SO@|$(plgdir)/npsqueak.so|" \
		npsqueakregister.in > $@
	chmod +x $@


clean:
	-rm -f *.o *.so *~ .*~ */*~ */.*~


############ install ####################################

$(ROOT)$(scriptdir):
	install -d $@

$(ROOT)$(plgdir): 
	install -d $@

$(ROOT)$(plgdir)/npsqueak.so: npsqueak.so $(ROOT)$(plgdir)
	cp npsqueak.so $@
	strip $@

$(ROOT)$(scriptdir)/npsqueakrun: npsqueakrun $(ROOT)$(scriptdir)
	cp npsqueakrun $@


$(ROOT)$(imgdir)/npsqueakregister: npsqueakregister $(ROOT)$(scriptdir)
	cp npsqueakregister $@

### Go! ###

NPSQUEAK_TARGETS=                   \
	$(ROOT)$(plgdir)/npsqueak.so    \
	$(ROOT)$(scriptdir)/npsqueakrun    \
	$(ROOT)$(scriptdir)/npsqueakregister

install: $(NPSQUEAK_TARGETS)

uninstall: 
	rmdir --ignore-fail-on-non-empty $(ROOT)$(imgdir)
	rm -rf $(NPSQUEAK_TARGETS)

## squeak-vm 3.9.8

=== platforms/unix/Makefile ===
# Last edited: 2005-03-16 22:47:32 by piumarta on squeak.hpl.hp.com

all : .force
	[ -d bld ] || mkdir bld
	[ -f bld/Makefile ] || ( cd bld; ../config/configure; )
	( cd bld; $(MAKE) $(MFLAGS); )

install : all
	( cd bld; $(MAKE) $(MFLAGS) install; )

clean : .force
	/bin/rm -rf bld

.force :

=== platforms/unix/config/Makefile ===
configure : .force
	./mkacinc > acplugins.m4
	aclocal
	autoconf
	rm acplugins.m4

.force :

=== platforms/unix/npsqueak/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Netscape Plugin for Squeak on Unix platforms
 # Author: Bert Freudenberg
-# Last edited: 2005-02-28 16:57:51 by jens on impara.de
+# Last edited: 2006-09-18 12:32:40 by piumarta on wireless-58.media.mit.edu
 
 ############ Customize flags here #######################
 
@@ -8,7 +8,7 @@
 CC	= gcc
 CFLAGS	= $(INC) -O2 -fPIC -Wall
 LD	= gcc
-LDFLAGS = -shared
+LDFLAGS = 
 
 # usually overridden from top level makefile
 VM_VERSION=  3.7b-5
@@ -24,17 +24,21 @@
 ############ compile and link ###########################
 all: npsqueak.so npsqueakrun
 
-npsqueak.so : npsqueak.o npunix.o 
-	$(LD) $(LDFLAGS) npsqueak.o npunix.o -o npsqueak.so 
+npsqueak.so : npsqueak.la 
+	-@rm -f $@ 
+	ln .libs/npsqueak $@ 
 
-npsqueak.o: npsqueak.c ../config.h
-	$(CC) -c $(CFLAGS) \
+npsqueak.la : npsqueak.lo npunix.lo 
+	../libtool --mode=link $(LD) $(LDFLAGS) npsqueak.lo npunix.lo -avoid-version -module -rpath $(plgdir) -o $@
+
+npsqueak.lo: npsqueak.c ../config.h
+	../libtool --mode=compile $(CC) -c $(CFLAGS) \
 		-DSYSTEM_BIN_DIR=\"$(scriptdir)\" \
 		-DSYSTEM_IMG_DIR=\"$(imgdir)\" \
 		-DNPSQUEAKRUN=\"$(npsqueakrun)\" $<
 
-npunix.o: npunix.c
-	$(CC) -c $(CFLAGS) $<
+npunix.lo: npunix.c
+	../libtool --mode=compile $(CC) -c $(CFLAGS) $<
 
 npsqueakrun: npsqueakrun.in 
 	sed "s|@imgdir@|$(imgdir)|; \
@@ -49,7 +53,7 @@
 
 
 clean:
-	-rm -f *.o *.so *~ .*~ */*~ */.*~
+	-rm -rf *.lo *.la *.o *.so *~ .*~ */*~ */.*~ .libs
 
 
 ############ install ####################################

## squeak-vm 3.11.3+svn2147

=== platforms/unix/CMakeLists.txt ===
# Yes, it's true: you can write makefiles in COBOL.
# 
# Last edited: 2009-08-27 19:30:47 by piumarta on emilia-2.local

PROJECT (squeak)

CMAKE_MINIMUM_REQUIRED (VERSION 2.6.2)

IF (NOT DEFINED VM_HOST OR NOT DEFINED VM_VERSION)
  MESSAGE (FATAL_ERROR "
    You MUST NOT run CMake directly the first time you configure a build.
    Run 'platforms/unix/cmake/configure' from within your build directory."
  )
ENDIF (NOT DEFINED VM_HOST OR NOT DEFINED VM_VERSION)

SET (prefix  ${CMAKE_INSTALL_PREFIX})

SET (version ${VM_VERSION})

SET (bindir bin)
SET (imgdir lib/squeak)
SET (plgdir lib/squeak/${version})
SET (mandir man/man1)
SET (docdir share/doc/squeak-${version})

GET_CMAKE_PROPERTY (vars VARIABLES)
FOREACH (opt ${vars})
  IF (opt MATCHES "OPT--.*")
    STRING (REGEX REPLACE "OPT--(.*)" "\\1" var ${opt})
    MESSAGE (STATUS "Setting ${var}=${${opt}}")
    SET (${var} ${${opt}})
  ENDIF ()
ENDFOREACH (opt)

SET (CMAKE_INSTALL_PREFIX ${prefix})

SET (bld    ${CMAKE_BINARY_DIR})
SET (unix   ${CMAKE_SOURCE_DIR})
SET (config ${unix}/cmake)

GET_FILENAME_COMPONENT (cross ${unix}/../Cross ABSOLUTE)

IF (OPT--src)
  GET_FILENAME_COMPONENT (src ${OPT--src} ABSOLUTE)
ELSE (SRC)
  SET (src  ${unix}/src)
ENDIF (OPT--src)

IF (NOT EXISTS ${src})
  MESSAGE (FATAL_ERROR "
    Source directory ${src} does not exist."
  )
ENDIF (NOT EXISTS ${src})

INCLUDE (${config}/Utils.cmake)
INCLUDE (${config}/Plugins.cmake)

STRING (REGEX REPLACE "([^-]*)-([^-]*)-([^-]*).*" "\\1" VM_HOST_CPU    ${VM_HOST})
STRING (REGEX REPLACE "([^-]*)-([^-]*)-([^-]*).*" "\\2" VM_HOST_VENDOR ${VM_HOST})
STRING (REGEX REPLACE "([^-]*)-([^-]*)-([^-]*).*" "\\3" VM_HOST_OS     ${VM_HOST})

SET (vm-host     "${VM_HOST}")
SET (vm-host-os  "${VM_HOST_OS}")
SET (vm-host-cpu "${VM_HOST_CPU}")

IF (OPT--CFLAGS)
  SET (CMAKE_C_FLAGS "${OPT--CFLAGS}")
ENDIF ()

IF (NOT CMAKE_C_FLAGS)
  IF (CMAKE_COMPILER_IS_GNUCC)
    IF     (VM_HOST_CPU MATCHES "i.86")
      SET (CMAKE_C_FLAGS "-g -O2 -fomit-frame-pointer")
    ELSEIF (VM_HOST_CPU STREQUAL "ppc" OR VM_HOST_CPU STREQUAL "powerpc")
      SET (CMAKE_C_FLAGS "-g -O3 -funroll-loops -mcpu=750 -mno-fused-madd")
    ENDIF ()
  ELSE ()
    SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS_RELEASE}")
  ENDIF (CMAKE_COMPILER_IS_GNUCC)
ENDIF (NOT CMAKE_C_FLAGS)

IF (NOT CMAKE_C_FLAGS)
  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS_RELEASE}")
ENDIF (NOT CMAKE_C_FLAGS)

MESSAGE (STATUS "Using CFLAGS ${CMAKE_C_FLAGS}")

MACRO (USE_LIBRARY lib)
  LIST (APPEND squeak_libs "${lib}")
ENDMACRO (USE_LIBRARY)

MACRO (USE_FRAMEWORK fwk)
  USE_LIBRARY ("-framework ${fwk}")
ENDMACRO (USE_FRAMEWORK)

MACRO (CONFIG_DEFINE var)
  LIST (APPEND config_vars "${var}")
ENDMACRO (CONFIG_DEFINE var)

SET (UNIX 1)
CONFIG_DEFINE (UNIX)

SET (CMAKE_SKIP_BUILD_RPATH TRUE)
SET (CMAKE_BUILD_WITH_INSTALL_RPATH TRUE) 
SET (CMAKE_INSTALL_RPATH "")
SET (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

INCLUDE (${unix}/vm/config.cmake)

CONFIGURE_PLUGINS ()

LIST (REMOVE_DUPLICATES config_vars)
FILE (WRITE ${bld}/config.h.in "")
FOREACH (var ${config_vars})
  FILE (APPEND ${bld}/config.h.in "#cmakedefine ${var} @${var}@\n")
ENDFOREACH (var)

CONFIGURE_FILE (${bld}/config.h.in ${bld}/config.h)

INCLUDE (${unix}/vm/build.cmake)

BUILD_PLUGINS ()

SET (cmake ${unix}/../../cmake)

IF (EXISTS ${cmake}/Packages.cmake)
  INCLUDE (${cmake}/Packages.cmake)
ENDIF ()

GET_CMAKE_PROPERTY (tmp VARIABLES)
LIST (REMOVE_ITEM tmp tmp)
LIST (SORT tmp)
FILE (WRITE ${bld}/config.status "")
FOREACH (var ${tmp})
  FILE (APPEND ${bld}/config.status "${var}=${${var}}\n")
ENDFOREACH ()

## squeak-vm 4.0.3.2202

=== unix/CMakeLists.txt ===
# Yes, it's true: you can write makefiles in COBOL.
# 
# Last edited: 2010-04-09 04:23:35 by piumarta on ubuntu

PROJECT (squeak)

CMAKE_MINIMUM_REQUIRED (VERSION 2.6.2)

IF (NOT DEFINED VM_HOST OR NOT DEFINED VM_VERSION)
  MESSAGE (FATAL_ERROR "
    You MUST NOT run CMake directly the first time you configure a build.
    Run 'platforms/unix/cmake/configure' from within your build directory."
  )
ENDIF (NOT DEFINED VM_HOST OR NOT DEFINED VM_VERSION)

SET (prefix  ${CMAKE_INSTALL_PREFIX})

SET (version ${VM_VERSION})

SET (bindir bin)
SET (imgdir lib/squeak)
SET (plgdir lib/squeak/${version})
SET (mandir man/man1)
SET (docdir share/doc/squeak-${version})

GET_CMAKE_PROPERTY (vars VARIABLES)
FOREACH (opt ${vars})
  IF (opt MATCHES "OPT--.*")
    STRING (REGEX REPLACE "OPT--(.*)" "\\1" var ${opt})
    MESSAGE (STATUS "Setting ${var}=${${opt}}")
    SET (${var} ${${opt}})
  ENDIF ()
ENDFOREACH (opt)

SET (CMAKE_INSTALL_PREFIX ${prefix})

SET (bld    ${CMAKE_BINARY_DIR})
SET (unix   ${CMAKE_SOURCE_DIR})
SET (config ${unix}/cmake)

GET_FILENAME_COMPONENT (cross ${unix}/../Cross ABSOLUTE)

IF (OPT--src)
  GET_FILENAME_COMPONENT (src ${OPT--src} ABSOLUTE)
ELSE (SRC)
  SET (src  ${unix}/src)
ENDIF (OPT--src)

IF (NOT EXISTS ${src})
  MESSAGE (FATAL_ERROR "
    Source directory ${src} does not exist."
  )
ENDIF (NOT EXISTS ${src})

INCLUDE (${config}/Utils.cmake)
INCLUDE (${config}/Plugins.cmake)

STRING (REGEX REPLACE "([^-]*)-([^-]*)-([^-]*).*" "\\1" VM_HOST_CPU    ${VM_HOST})
STRING (REGEX REPLACE "([^-]*)-([^-]*)-([^-]*).*" "\\2" VM_HOST_VENDOR ${VM_HOST})
STRING (REGEX REPLACE "([^-]*)-([^-]*)-([^-]*).*" "\\3" VM_HOST_OS     ${VM_HOST})

SET (vm-host     "${VM_HOST}")
SET (vm-host-os  "${VM_HOST_OS}")
SET (vm-host-cpu "${VM_HOST_CPU}")

IF (OPT--CFLAGS)
  SET (CMAKE_C_FLAGS "${OPT--CFLAGS}")
ENDIF ()

IF (CMAKE_ARCH_FLAGS STREQUAL "-m32")
  IF (VM_HOST_CPU STREQUAL "x86_64")
    SET (VM_HOST_CPU "i386")
  ENDIF ()
ENDIF ()

IF (NOT CMAKE_C_FLAGS)
  IF (CMAKE_COMPILER_IS_GNUCC)
    IF     (VM_HOST_CPU MATCHES "i.86")
      SET (CMAKE_C_FLAGS "-g -O2 -fomit-frame-pointer")
    ELSEIF (VM_HOST_CPU STREQUAL "ppc" OR VM_HOST_CPU STREQUAL "powerpc")
      SET (CMAKE_C_FLAGS "-g -O3 -funroll-loops -mcpu=750 -mno-fused-madd")
    ENDIF ()
  ELSE ()
    SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS_RELEASE}")
  ENDIF (CMAKE_COMPILER_IS_GNUCC)
ENDIF (NOT CMAKE_C_FLAGS)

IF (NOT CMAKE_C_FLAGS)
  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS_RELEASE}")
ENDIF (NOT CMAKE_C_FLAGS)

IF (CMAKE_ARCH_FLAGS)
  SET (CMAKE_C_FLAGS "${CMAKE_ARCH_FLAGS} ${CMAKE_C_FLAGS}")
ENDIF (CMAKE_ARCH_FLAGS)

MESSAGE (STATUS "Using CFLAGS ${CMAKE_C_FLAGS}")

MACRO (USE_LIBRARY lib)
  LIST (APPEND squeak_libs "${lib}")
ENDMACRO (USE_LIBRARY)

MACRO (USE_FRAMEWORK fwk)
  USE_LIBRARY ("-framework ${fwk}")
ENDMACRO (USE_FRAMEWORK)

MACRO (CONFIG_DEFINE var)
  LIST (APPEND config_vars "${var}")
ENDMACRO (CONFIG_DEFINE var)

SET (UNIX 1)
CONFIG_DEFINE (UNIX)

SET (ioMicroSecondClock ioMicroSeconds)
CONFIG_DEFINE (ioMicroSecondClock)

SET (ioUtcWithOffset sqUnixUtcWithOffset)
CONFIG_DEFINE (ioUtcWithOffset)

SET (CMAKE_SKIP_BUILD_RPATH TRUE)
SET (CMAKE_BUILD_WITH_INSTALL_RPATH TRUE) 
SET (CMAKE_INSTALL_RPATH "")
SET (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

INCLUDE (${unix}/vm/config.cmake)

CONFIGURE_PLUGINS ()

LIST (REMOVE_DUPLICATES config_vars)
FILE (WRITE ${bld}/config.h.in "")
FOREACH (var ${config_vars})
  FILE (APPEND ${bld}/config.h.in "#cmakedefine ${var} @${var}@\n")
ENDFOREACH (var)

CONFIGURE_FILE (${bld}/config.h.in ${bld}/config.h)

INCLUDE (${unix}/vm/build.cmake)

BUILD_PLUGINS ()

SET (cmake ${unix}/../../cmake)

IF (EXISTS ${cmake}/Packages.cmake)
  INCLUDE (${cmake}/Packages.cmake)
ENDIF ()

GET_CMAKE_PROPERTY (tmp VARIABLES)
LIST (REMOVE_ITEM tmp tmp)
LIST (SORT tmp)
FILE (WRITE ${bld}/config.status "")
FOREACH (var ${tmp})
  FILE (APPEND ${bld}/config.status "${var}=${${var}}\n")
ENDFOREACH ()

=== debian/changelog ===
squeak-vm (1:4.0.3.2202-2) unstable; urgency=low

  * Fix error in debian/rules

 -- José L. Redrejo Rodríguez <jredrejo@debian.org>  Sat, 17 Apr 2010 20:17:57 +0200

squeak-vm (1:4.0.3.2202-1) unstable; urgency=low

  * New upstream release (Closes: #533845)
  * Enabled mpeg plugin only on i386 arch (Closes: #567366)
  * Switch to dpkg-source 3.0 (quilt) format  
  * debian/control:
     - bumped standards version to 3.8.4
     - added quilt build dependency
     - changes dependency from xterm to x-terminal-emulator
     (Closes: #498782)
  * debian/rules: modified to use quilt  
  * Added epoch field to help collaborative mainteinance with other
    Debian based distributions (Closes: #576444)
  * removed sound64bits.dpatch as it's been included upstream
  * debian/patches/mpeg_includes.patch for missing includes (Thanks to 
    Petter Petter Reinholdtsen at #567366)
    
 -- José L. Redrejo Rodríguez <jredrejo@debian.org>  Thu, 15 Apr 2010 12:14:14 +0200

squeak-vm (3.11.3+svn2147-1) unstable; urgency=low

  * New upstream release, with new RomePlugin and GstreamerPlugin, 
    pulseaudio support and use cmake to compile (Closes: #552907)
  * Links every sources file to the user squeak directory
  * Fixes plugin links
  * Removed 20_sym_link_patch and fixImplicitidConvertedPointer.dpatch 
    patches as they're included upstream
  * Added sound64bits.dpatch (Closes: #487871)
  * Reintroduced MPEG3Plugin as it uses the same sources and headers the
    current libmpeg3 package in Debian
  * xresetcapslock removed as the vm now doesn't interprets CAPS LOCK as
    SHIFT being down
  * Removed browser plugin as it is not maintained upstream by now
  * debian/postinst: squeaklets directory now points to /tmp (Closes: #488134)
  * linex.dpatch: fixes images detection and desktop file (Closes: #496559)
  * Bumped standards version to 3.8.3: added debian/README.source
  * Disabled RomePlugin for all archs except i386

 -- José L. Redrejo Rodríguez <jredrejo@debian.org>  Sun, 27 Dec 2009 16:16:46 +0100

squeak-vm (3.10.3+svn1902.dfsg-1) unstable; urgency=low

  * New upstream release (Include new plugins for ogg, gstreamer & dbus)
  * Following patches have been removed as they are applied upstream:
    - 10_configure
    - 15_biasToGrow
    - 64bits_SocketPlugin.dpatch
  * disabled 30_window_icon as it does not work correctly once compiled
  * debian/control: 
    - new build dependencies to compile new plugins: libdbus-1-dev,
      libgstreamer0.10-dev, libvorbis-dev
    - added autotools-dev as build dependency to regenerate config.sub 
      and config.guess files
    - Bumped standards-version to 3.8.0 (no changes required)
    
 -- José L. Redrejo Rodríguez <jredrejo@debian.org>  Tue, 17 Jun 2008 10:47:30 +0200

squeak-vm (3.9.12+svn1820.dfsg-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Build depend on libffi-dev instead of libffi4-dev. Closes: #479712.

 -- Frans Pop <fjp@debian.org>  Fri, 09 May 2008 23:38:57 +0200

squeak-vm (3.9.12+svn1820.dfsg-2) unstable; urgency=low

  * Updated squeak launcher man page (Closes: #471436)
  * Fixed launcher error and changed its interpreter (Closes: #472220)
  * Created fixImplicitidConvertedPointer.dpatch (Closes: #471272)

 -- José L. Redrejo Rodríguez <jredrejo@debian.org>  Sat, 22 Mar 2008 23:04:03 +0100

squeak-vm (3.9.12+svn1820.dfsg-1) unstable; urgency=low

  * First official Debian release (Closes: #454635).
  * Updated libtool files
  * Removed MPEG3Plugin as even it's LGPL licensed contains code under
    some evil patents.
  * Following patches have been applied to the upstream svn version
    - 10_configure
    - 15_biasToGrow: biasToGrow code typo (Squeak #6667)
    - 20_sym_link_patch: fix symlinks on Linux
    - 30_window_icon: add an icon to the Squeak window (by Matej Kosik)
    - 50_defaultSourcesSystemAttribute: set default place for sources
    - npsqueak: modify plugin launcher to work in Debian 
    - 64bits_SocketPlugin: fix a segfault in the 64 bits (Squeak #5688)
    - linex: legacy files from previous Squeak package in gnuLinEx 
  * platforms/Cross/plugins/JPEGReadWriter2Plugin/README added as it
    was lost in the svn and contains license text for this plugin
  * Added launcher desktop friendly, desktop integration and icons

 -- José L. Redrejo Rodríguez <jredrejo@debian.org>  Wed, 05 Mar 2008 19:54:53 +0100

=== debian/control ===
Source: squeak-vm
Section: interpreters
Priority: optional
Maintainer: Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>
Uploaders: José L. Redrejo Rodríguez <jredrejo@debian.org>
Build-Depends: debhelper (>= 5.0.42), autotools-dev, quilt, cmake (>= 2.6.2), libxt-dev, libgl1-mesa-dev, libasound2-dev, uuid-dev, libspeex-dev, libxtst-dev, libxrender-dev, sharutils, libffi-dev, libdbus-1-dev, libgstreamer0.10-dev, libvorbis-dev,  libfreetype6-dev, libpango1.0-dev, libcairo2-dev, libpulse-dev
Standards-Version: 3.8.4

Package: squeak-vm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, whiptail, xterm | x-terminal-emulator, gettext-base
Recommends: zenity | kdebase-bin
Suggests: squeak-sources, squeak-plugin, squeak-image
Description: The Squeak Smalltalk System (virtual machine)
 Squeak is a full-featured implementation of the Smalltalk programming
 language and environment based on (and largely compatible with) the
 original Smalltalk-80 system.
 .
 This package contains just the Squeak virtual machine.  If you are
 new to Squeak then you will have to install a Squeak image too before
 you can run Squeak. Squeak images can be downloaded from
 http://www.squeak.org, http://www.squeakland.org or 
 http://squeak.educarex.es

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

include /usr/share/quilt/quilt.make

# This is the Squeak version we are compiling
#debversion=$(shell grep AC_VM_VERSION  unix/config/configure.ac  | tr -dc '0-9a-z,' | cut -d ',' -f 1-3 | tr ',' '.')
debversion=$(shell grep VMMaker unix/src/vm/interp.h|tr '\015 ' '\012\012'|sed '1,/VMMaker/d;q')
debianmajor=$(shell echo $(debversion) | cut -d . -f 1)
debianminor=$(shell echo $(debversion) | cut -d . -f 2)
debianultraminor=$(shell echo $(debversion) | cut -d . -f 3)
svnversion=2202
debianversion=$(debianmajor).$(debianminor).$(debianultraminor)-$(svnversion)
#debianversion=$(debversion)-$(svnversion)

BUILD_TREE=$(CURDIR)/build-tree

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

INSTALL_PROGRAM = install
CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

CMAKE_OPTS = -Wno-dev -D CMAKE_INSTALL_PREFIX=/usr -D CMAKE_SKIP_RPATH=TRUE -D BINDINGS_GLOBAL_INSTALL=TRUE -D PEDANTIC=TRUE
ifneq ($(DEB_HOST_ARCH),i386)
	CONFIG_OPTS=--without-RomePlugin --without-Mpeg3Plugin
endif

configure: patch configure-stamp
configure-stamp: 
	dh_testdir
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub unix/cmake/config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess unix/cmake/config.guess
endif
	
	#put svn version for the squeak lib directory:
#	echo $(svnversion)>unix/svnversion
	# Perform an out-of-tree build to keep a clean source tree
	mkdir $(BUILD_TREE)
	cd $(BUILD_TREE); ../unix/cmake/configure $(CONFIG_OPTS) \
		--host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE)  \
		--prefix=/usr --mandir=/usr/share/man 
	cd $(BUILD_TREE); cmake .. \
		-DCMAKE_INSTALL_PREFIX:STRING="/usr" \
		-DCMAKE_C_FLAGS:STRING="$(CFLAGS)" \
		../unix

	touch $@


build: configure build-stamp
build-stamp:
	dh_testdir
	cd $(BUILD_TREE); $(MAKE)

    # uudecode desktop icons:
	for i in changeset changes image project sources; do \
	  f=linex/gnome-mime-application-squeak-$$i.png; \
	  if [ ! -s $$f ]; then \
	    uudecode -o $$f $$f.uu ; \
	    touch -r $$f.uu $$f ;\
	fi; \
	done    
	if [ ! -s linex/squeak.png ]; then \
	    uudecode -o linex/squeak.png linex/squeak.png.uu ; \
	    touch -r linex/squeak.png.uu linex/squeak.png;\
	fi
	    	
	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	rm -f unix/cmake/config.sub unix/cmake/config.guess
	${MAKE} -f debian/rules unpatch	
#	rm -f unix/svnversion
#	rm -Rf unix/config
	rm -rf $(BUILD_TREE)
	rm -rf linex
		
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	cd $(BUILD_TREE); $(MAKE) install DESTDIR=$(CURDIR)/debian/squeak-vm $(INSTALL_OVERRIDES)
	cp -f $(CURDIR)/linex/squeakmime.debian $(CURDIR)/debian/squeak-vm/usr/lib/mime/packages/squeak
	strip -s --remove-section=.comment debian/squeak-vm/usr/lib/squeak/$(debianversion)/*
	rm -f $(CURDIR)/debian/squeak-vm/usr/bin/squeak.sh
	for y in linex/po/*.po; do \
	  i=`basename $$y .po`; \
	  mkdir -p $(CURDIR)/debian/squeak-vm/usr/share/locale/$$i/LC_MESSAGES/; \
	  msgfmt $$y -o $(CURDIR)/debian/squeak-vm/usr/share/locale/$$i/LC_MESSAGES/squeak.mo --statistics ; \
	done 

	dh_install

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installmenu
	dh_installchangelogs unix/ChangeLog
	dh_installmenu
	dh_installmime
	dh_installman
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb


binary:  binary-arch  binary-indep

# print the current version, as this file sees it
version::
	@echo "The Debian version is $(debversion)"
	@echo "Ian's version number is $(debianversion)"

.PHONY: build clean binary-indep binary-arch binary install configure

## squeak-vm 4.4.7.2357

=== unix/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Yes, it's true: you can write makefiles in COBOL.
 # 
-# Last edited: 2010-04-09 04:23:35 by piumarta on ubuntu
+# Last edited: 2010-05-13 12:54:20 by piumarta on emilia-2.local
 
 PROJECT (squeak)
 
@@ -137,6 +137,8 @@
 
 BUILD_PLUGINS ()
 
+ADD_SUBDIRECTORY (${unix}/npsqueak)
+
 SET (cmake ${unix}/../../cmake)
 
 IF (EXISTS ${cmake}/Packages.cmake)

=== debian/changelog ===
squeak-vm (1:4.4.7.2357-1) unstable; urgency=low

  * New upstream release (Closes: #625861)
  * debian/control:
     - bumped standards version to 3.9.2  
     - fixed suggestions in debian/control (Closes: #528156)
  * Disabled npsqueak patch, as browser plugin doesn't compile

 -- José L. Redrejo Rodríguez <jredrejo@debian.org>  Sat, 07 May 2011 11:18:30 +0200

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,14 @@
 Maintainer: Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>
 Uploaders: José L. Redrejo Rodríguez <jredrejo@debian.org>
 Build-Depends: debhelper (>= 5.0.42), autotools-dev, quilt, cmake (>= 2.6.2), libxt-dev, libgl1-mesa-dev, libasound2-dev, uuid-dev, libspeex-dev, libxtst-dev, libxrender-dev, sharutils, libffi-dev, libdbus-1-dev, libgstreamer0.10-dev, libvorbis-dev,  libfreetype6-dev, libpango1.0-dev, libcairo2-dev, libpulse-dev
-Standards-Version: 3.8.4
+Standards-Version: 3.9.2
+Homepage: http://www.squeakvm.org/unix/
 
 Package: squeak-vm
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, whiptail, xterm | x-terminal-emulator, gettext-base
 Recommends: zenity | kdebase-bin
-Suggests: squeak-sources, squeak-plugin, squeak-image
+Suggests: etoys
 Description: The Squeak Smalltalk System (virtual machine)
  Squeak is a full-featured implementation of the Smalltalk programming
  language and environment based on (and largely compatible with) the

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,7 @@
 debianmajor=$(shell echo $(debversion) | cut -d . -f 1)
 debianminor=$(shell echo $(debversion) | cut -d . -f 2)
 debianultraminor=$(shell echo $(debversion) | cut -d . -f 3)
-svnversion=2202
+svnversion=2357
 debianversion=$(debianmajor).$(debianminor).$(debianultraminor)-$(svnversion)
 #debianversion=$(debversion)-$(svnversion)
 
@@ -56,11 +56,11 @@
 	mkdir $(BUILD_TREE)
 	cd $(BUILD_TREE); ../unix/cmake/configure $(CONFIG_OPTS) \
 		--host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE)  \
-		--prefix=/usr --mandir=/usr/share/man 
+		--with-npsqueak --prefix=/usr --mandir=/usr/share/man 
 	cd $(BUILD_TREE); cmake .. \
 		-DCMAKE_INSTALL_PREFIX:STRING="/usr" \
 		-DCMAKE_C_FLAGS:STRING="$(CFLAGS)" \
-		../unix
+		../unix		
 
 	touch $@
 
@@ -68,6 +68,7 @@
 build: configure build-stamp
 build-stamp:
 	dh_testdir
+
 	cd $(BUILD_TREE); $(MAKE)
 
     # uudecode desktop icons:

## squeak-vm 4.10.2.2614

=== Makefile ===
all : .force
	test -d bld || mkdir bld
	(cd bld; ../unix/cmake/configure)
	(cd bld; make)

install : all
	(cd bld; make install)

clean : .force
	/bin/rm -rf bld

.force :

=== unix/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Yes, it's true: you can write makefiles in COBOL.
 # 
-# Last edited: 2010-05-13 12:54:20 by piumarta on emilia-2.local
+# Last edited: 2012-09-16 21:19:57 by piumarta on linux64
 
 PROJECT (squeak)
 
@@ -13,13 +13,19 @@
   )
 ENDIF (NOT DEFINED VM_HOST OR NOT DEFINED VM_VERSION)
 
+IF (DEFINED OPT--image64)
+  SET (SQ_VI_BYTES_PER_WORD 8)
+  SET (versionsuffix "_64bit")
+  SET (scriptsuffix "64")
+ENDIF (DEFINED OPT--image64)
+
 SET (prefix  ${CMAKE_INSTALL_PREFIX})
 
 SET (version ${VM_VERSION})
 
 SET (bindir bin)
 SET (imgdir lib/squeak)
-SET (plgdir lib/squeak/${version})
+SET (plgdir lib/squeak/${version}${versionsuffix})
 SET (mandir man/man1)
 SET (docdir share/doc/squeak-${version})
 
@@ -93,6 +99,18 @@
   SET (CMAKE_C_FLAGS "${CMAKE_ARCH_FLAGS} ${CMAKE_C_FLAGS}")
 ENDIF (CMAKE_ARCH_FLAGS)
 
+IF (EXISTS /usr/pkg/include)
+  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -I/usr/pkg/include")
+ENDIF (EXISTS /usr/pkg/include)
+
+IF (EXISTS /usr/local/include)
+  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -I/usr/local/include")
+ENDIF (EXISTS /usr/local/include)
+
+IF (EXISTS /usr/local/lib)
+  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -L/usr/local/lib")
+ENDIF (EXISTS /usr/local/lib)
+
 MESSAGE (STATUS "Using CFLAGS ${CMAKE_C_FLAGS}")
 
 MACRO (USE_LIBRARY lib)

=== unix/doc/Makefile ===
MAIN = HowToBuildFromSource

all : $(MAIN).ps $(MAIN).html/$(MAIN).html $(MAIN).pdf $(MAIN).txt

dvi : $(MAIN).dvi

.SUFFIXES : .tex .dvi .ps .pdf .html .txt

.ps.pdf :
	ps2pdf $< $@

.dvi.ps :
#	dvips -P cmz -o $@ $<
	dvips -o $@ $<

.tex.dvi : .force
	latex $(MAIN).tex
	latex $(MAIN).tex
	makeindex $(MAIN).idx
	latex $(MAIN).tex

$(MAIN).html/%.html : %.tex Makefile
	test -d tmp || mkdir tmp
	latex2html -dir tmp -local_icons -auto_prefix -show_section_numbers -split 4 $(MAIN).tex
	test -d $(MAIN).html || mkdir $(MAIN).html
	cp -p tmp/*.html tmp/*.css tmp/*.png $(MAIN).html/.
	/bin/rm -rf tmp

$(MAIN).txt : $(MAIN).tex html2text.rc Makefile
	test -d tmp || mkdir tmp
	latex2html -dir tmp -nonavigation -noinfo -show_section_numbers -split 0 $(MAIN).tex
	html2text -rcfile html2text.rc -nobs tmp/$(MAIN).html | uniq > $@
	/bin/rm -rf tmp

clean : .force
	/bin/rm -f *~ *.{aux,idx,ilg,ind,log,out,toc}

distclean : clean
	/bin/rm -rf $(MAIN).html
	/bin/rm -f *.{dvi,ps,pdf,txt}

.force :

=== unix/npsqueak/Makefile ===
# Netscape Plugin for Squeak on Unix platforms
# Author: Bert Freudenberg
# Last edited: 2007-10-12 20:03:33 by piumarta on emilia

############ Customize flags here #######################

INC	= -I./include -I/usr/X11R6/include
CC	= gcc
CFLAGS	= $(INC) -O2 -fPIC -Wall
LD	= gcc
LDFLAGS = -L/usr/X11R6/lib -lXt

# usually overridden from top level makefile
VM_VERSION=  3.9-12
bindir=	     /usr/local/bin
imgdir=	     /usr/local/share/squeak
plgdir=	     /usr/local/lib/squeak/$(VM_VERSION)

# configuration
scriptdir=	$(imgdir)
npsqueakrun=	npsqueakrun


############ compile and link ###########################
all: npsqueak.so npsqueakrun

npsqueak.so : npsqueak.la 
	-@rm -f npsqueak.so
	ln .libs/npsqueak npsqueak.so

npsqueak.la : npsqueak.lo npunix.lo 
	../libtool --mode=link $(LD) $(LDFLAGS) npsqueak.lo npunix.lo -avoid-version -module -rpath $(plgdir) -o npsqueak.la

npsqueak.lo: npsqueak.c ../config.h
	../libtool --mode=compile $(CC) -c $(CFLAGS) \
		-DSYSTEM_BIN_DIR=\"$(scriptdir)\" \
		-DSYSTEM_IMG_DIR=\"$(imgdir)\" \
		-DNPSQUEAKRUN=\"$(npsqueakrun)\" npsqueak.c

npunix.lo: npunix.c
	../libtool --mode=compile $(CC) -c $(CFLAGS) npunix.c

npsqueakrun: npsqueakrun.in 
	sed "s|@imgdir@|$(imgdir)|; \
	     s|@VM_VERSION@|$(VM_VERSION)|" \
		npsqueakrun.in > npsqueakrun
	chmod +x npsqueakrun

npsqueakregister: npsqueakregister.in 
	sed "s|@NPSQUEAK_SO@|$(plgdir)/npsqueak.so|" \
		npsqueakregister.in > npsqueakregister
	chmod +x npsqueakregister


clean:
	-rm -rf *.lo *.la *.o *.so *~ .*~ */*~ */.*~ .libs


############ install ####################################

$(ROOT)$(scriptdir):
	install -d $(ROOT)$(scriptdir)

$(ROOT)$(plgdir): 
	install -d $(ROOT)$(plgdir)

$(ROOT)$(plgdir)/npsqueak.so: npsqueak.so $(ROOT)$(plgdir)
	cp npsqueak.so $(ROOT)$(plgdir)/npsqueak.so
	strip $(ROOT)$(plgdir)/npsqueak.so

$(ROOT)$(scriptdir)/npsqueakrun: npsqueakrun $(ROOT)$(scriptdir)
	cp npsqueakrun $(ROOT)$(scriptdir)/npsqueakrun


$(ROOT)$(imgdir)/npsqueakregister: npsqueakregister $(ROOT)$(scriptdir)
	cp npsqueakregister $(ROOT)$(imgdir)/npsqueakregister

### Go! ###

NPSQUEAK_TARGETS=                   \
	$(ROOT)$(plgdir)/npsqueak.so    \
	$(ROOT)$(scriptdir)/npsqueakrun    \
	$(ROOT)$(scriptdir)/npsqueakregister

install: $(NPSQUEAK_TARGETS)

uninstall: 
	rmdir --ignore-fail-on-non-empty $(ROOT)$(imgdir)
	rm -rf $(NPSQUEAK_TARGETS)

=== debian/changelog ===
squeak-vm (1:4.10.2.2614-8) unstable; urgency=medium

  * Add patch to add sa_restorer on HPPA.
    Closes: Bug#528774. Thanks to Philipp Kern and John David Anglin.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 26 Sep 2018 12:52:07 +0200

squeak-vm (1:4.10.2.2614-7) unstable; urgency=medium

  * Update patches:
    + Add patch cherry-picked form OpenSmalltalk to fix CameraPlugin for
      64bit unix.
      Closes: Bug#892016.
      Thanks to Bernhard Übelacker, Adrian Bunk, and Tobias Pape.
    + Drop obsolete unused patch npsqueak.patch.
    + Add/update DEP-3 patch headers.
  * Declare compliance with Debian Policy 4.2.1.
  * Set Rules-Requires-Root: no.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 22 Sep 2018 14:35:04 +0200

squeak-vm (1:4.10.2.2614-6) unstable; urgency=medium

  * Limit compiler optimization workaround to adding compile options
    -fno-caller-saves -fno-strict-overflow -fno-strict-aliasing
    (not -O1).
    See Bug#872252.
  * Update shell wrapper:
    + Fix revert to use $HOME (not ~)
      when not immediately resolved by shell.
    + Fix use find (not shell globbing)
      to avoid creating broken symlink as bogus fallback.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 16 Jul 2018 12:36:41 +0200

squeak-vm (1:4.10.2.2614-5) unstable; urgency=medium

  * Move maintenance to the Sugar team, with myself as uploader.
    Thanks for your past contributions, José.
  * Update Vcs-* fields: Source moved to Salsa.
  * Wrap-and-sort debian hint files.
  * Update package relations:
    + Recommend kdialog (not kdebase-bin).
      Closes: Bug#885841. Thanks to Pino Toscano.
    + Relax to build-depend unversioned on cdbs:
      Needed version satisfied even in oldstable.
    + Stop build-depend on dh-buildinfo.
  * Use debhelper compatibility level 9 (not 8).
  * Modernize cdbs:
    + Drop upstream-tarball hints: Use gbp import-orig --uscan.
  * Drop README.source: Bogusly talks about unused control.in file.
  * Adjust short description to mention Smalltalk
    (and not Unix nor repeat package name).
  * Update shell wrapper:
    + Modernize to use $$(...) (not `...`)
    + Avoid useless use of echo.
    + Use mktemp (not deprecated tempfile).
    + Avoid superfluous dollar in arithmetics.
    + Simplify resolving internal variables IMAGE_DIR VM.
    + Fix obey custom SQUEAK_IMAGE_DIR
      (not use hardcoded path when single image located).
    + Use find (not cd + ls) to locate images).
    + Simplify resolving if first parameter is a project file.
    + Simplify resolving if image path is relative.
    + Check exit code explicitly.
    + Store positional parameters explicitly.
    + Fix handle multiple images with same basename.
    + Use ~ (not $HOME).
    + Fix use multi-argument syntax when calling x-terminal-emulator.
    + Fix escape image paths, to handle oddly named images.
    + Simplify tests.
    + Fix quote variables.
    + Use POSIX shell (not bash).
    + Tidy whitespace.
  * Declare compliance with Debian Policy 4.1.5.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 15 Jul 2018 23:08:29 +0200

squeak-vm (1:4.10.2.2614-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build with -O1 to work around bugs exposed by better
    optimization in recent gcc versions. (Closes: #862576)

 -- Adrian Bunk <bunk@debian.org>  Wed, 07 Jun 2017 12:05:13 +0300

squeak-vm (1:4.10.2.2614-4) unstable; urgency=medium

  * Fix use system shared config.guess and config.sub (not old local
    versions).
    Closes: bug#804164. Thanks to Jurica Stanojkovic.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 09 Nov 2015 10:24:52 +0100

squeak-vm (1:4.10.2.2614-3) unstable; urgency=medium

  * Gix stop build-depend on libgstreamer0.10-dev: Plugin isn't built
    anyway.
    Closes: Bug#799726. Thanks to Moritz Muehlenhoff and Tobias Pape.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 28 Oct 2015 17:34:33 +0100

squeak-vm (1:4.10.2.2614-2) unstable; urgency=medium

  * Update README.source to emphasize that control.in file is *not* a
    show-stopper for contributions.
  * Move packaging to pkg-squeak team governance.
  * Declare compliance with Debian Policy 3.9.6.
  * Improve short and long description, avoiding article in short
    description, and referencing Debian packages (not web pages) for
    Squeak images.
  * Modernize CDBS use:
    + Have utils.mk put aside cruft during build.
      Tighten to build-depend on recent cdbs.
    + Stop needlessly relax upstream-tarball.mk inclusion.
    + Include cmake.mk (bypassing upstream configure script): Enables
      fortifying options.
  * Fix menu file.
  * Recommend scratch with etoys as fallback (and stop suggest etoys).
    Closes: bug#603797. Thanks to Ronny Standtke.
  * Remove /usr/share/squeak dir when purging package.
    Closes: Bug#658108. Thanks to Andreas Beckmann.
  * Fix drop Education tag from desktop file.
    Closes: Bug#611115. Thanks to Chris Wilson.
  * Fix FTBFS with build-flag --as-needed.
    Closes: Bug#710367. Thanks to Julian Taylor.
  * Fix build-depend on libasound2-dev only on Linux archs, and
    build-exclude it elsewhere.
    Closes: Bug#696606. Thanks to Steven Chamberlain.
  * Fix disable FFIPrims plugin on powerpcspe.
    Closes: Bug#693633. Thanks to Roland Stigge.
  * Add patch to fix FTBFS with clang.
    Closes: bug#740972. Thanks to Nicolas Sévelin-Radiguet.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 21 Jul 2015 20:02:34 +0200

squeak-vm (1:4.10.2.2614-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * Change B-D to libjpeg-dev to finish the transition to libjpeg-turbo
    (Closes: #763494)

 -- Ondřej Surý <ondrej@debian.org>  Mon, 29 Sep 2014 17:06:04 +0200

squeak-vm (1:4.10.2.2614-1) unstable; urgency=low

  [ upstream ]
  * New upstream release.
    Changes since last packaged release:
    + Support building and installing VMs for 64-bit images.
    + UUIDPlugin can use uuid_create().
    + Link squeakvm against libiconv if necessary.
    + Search /usr/local and /usr/pkg for headers and libs.


=== debian/control ===
Source: squeak-vm
Section: interpreters
Priority: optional
Maintainer: Debian Sugar Team <pkg-sugar-devel@lists.alioth.debian.org>
Uploaders:
 Jonas Smedegaard <dr@jones.dk>,
Build-Depends:
 autotools-dev,
 cdbs,
 cmake,
 debhelper,
 libasound2-dev [linux-any],
 libcairo2-dev,
 libdbus-1-dev,
 libffi-dev,
 libfreetype6-dev,
 libgl1-mesa-dev,
 libjpeg-dev,
 libpango1.0-dev,
 libpcre3-dev,
 libpulse-dev,
 libspeex-dev,
 libvorbis-dev,
 libxrender-dev,
 libxt-dev,
 libxtst-dev,
 sharutils,
 uuid-dev,
Build-Conflicts:
 libasound2-dev [!linux-any],
Standards-Version: 4.2.1
Homepage: http://www.squeakvm.org/unix/
Vcs-Git: https://salsa.debian.org/pkg-sugar-team/squeak-vm.git
Vcs-Browser: https://salsa.debian.org/pkg-sugar-team/squeak-vm
Rules-Requires-Root: no

Package: squeak-vm
Architecture: any
Depends:
 gettext-base,
 whiptail,
 xterm | x-terminal-emulator,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 scratch | etoys,
 zenity | kdialog
Description: virtual machine for Smalltalk
 Squeak is a full-featured implementation of the Smalltalk programming
 language and environment based on (and largely compatible with) the
 original Smalltalk-80 system.
 .
 This package contains just the Unix Squeak virtual machine.  You will
 likely need also an image file containing a "snapshot" of a live Squeak
 session - e.g. one of the Debian packages etoys or scratch.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# code not written for optimizations of GCC 4.2.1 and newer
# <https://smallissimo.blogspot.com/2013/02/compiling-squeak-cog-virtual-machine-on.html>
export DEB_CFLAGS_MAINT_APPEND = -fno-caller-saves -fno-strict-overflow -fno-strict-aliasing

include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk

pkg = $(DEB_SOURCE_PACKAGE)

# Put aside convenience code copies during build
DEB_UPSTREAM_CRUFT_MOVE = Cross/plugins/RePlugin/pcre.c \
 Cross/plugins/RePlugin/pcre.h
# all j*.[ch] except jmemd*.c and jinclude.h
jpegfiles = jcapimin.c jcapistd.c jccoefct.c jccolor.c jcdctmgr.c
jpegfiles += jchuff.c jchuff.h jcinit.c jcmainct.c jcmarker.c jcmaster.c
jpegfiles += jcomapi.c jconfig.h jcparam.c jcphuff.c jcprepct.c
jpegfiles += jcsample.c jctrans.c jdapimin.c jdapistd.c jdatadst.c
jpegfiles += jdatasrc.c jdcoefct.c jdcolor.c jdct.h jddctmgr.c jdhuff.c
jpegfiles += jdhuff.h jdinput.c jdmainct.c jdmarker.c jdmaster.c
jpegfiles += jdmerge.c jdphuff.c jdpostct.c jdsample.c jdtrans.c
jpegfiles += jerror.c jerror.h jfdctflt.c jfdctfst.c jfdctint.c
jpegfiles += jidctflt.c jidctfst.c jidctint.c jidctred.c jmemmgr.c
jpegfiles += jmemnobs.c jmemsys.h jmorecfg.h jpegint.h jpeglib.h
jpegfiles += jquant1.c jquant2.c jutils.c jversion.h
DEB_UPSTREAM_CRUFT_MOVE += \
 $(patsubst %,Cross/plugins/JPEGReadWriter2Plugin/%,$(jpegfiles))

DEB_SRCDIR = unix
DEB_BUILDDIR = build-tree

DEB_MAKE_INSTALL_TARGET = install DESTDIR=$(cdbs_curdestdir)

ifneq ($(DEB_HOST_ARCH),i386)
	CONFIG_OPTS=--without-RomePlugin --without-Mpeg3Plugin
endif

# FFIPrims plugin uses assembler code unsupported on powerpcspe
ifeq ($(DEB_HOST_ARCH),powerpcspe)
	CONFIG_OPTS=--without-SqueakFFIPrims
endif

vmmversion = $(basename $(DEB_UPSTREAM_TARBALL_VERSION))
svnversion = $(subst .,,$(suffix $(DEB_UPSTREAM_TARBALL_VERSION)))
guess := $(shell /usr/share/misc/config.guess)
sub := $(shell /usr/share/misc/config.sub $(guess))
DEB_CMAKE_EXTRA_FLAGS += -DVM_HOST=$(sub)
DEB_CMAKE_EXTRA_FLAGS += -DVM_VERSION=$(vmmversion)-$(svnversion)
DEB_CMAKE_EXTRA_FLAGS += -DPLATFORM_SOURCE_VERSION=$(svnversion)
DEB_CMAKE_EXTRA_FLAGS += -DOPT--prefix=$(DEB_CMAKE_INSTALL_PREFIX)
CONFIG_OPTS += --with-npsqueak
DEB_CMAKE_EXTRA_FLAGS += $(patsubst %,-DOPT%=1,$(CONFIG_OPTS))

# Upstream README contains no parts relevant for Debian usage
DEB_INSTALL_DOCS_ALL =

DEB_INSTALL_CHANGELOGS_ALL = unix/ChangeLog
DEB_INSTALL_MANPAGES_$(pkg) = debian/squeak.1

install/$(pkg)::
	for y in debian/po/*.po; do \
	  i=`basename $$y .po`; \
	  mkdir -p $(cdbs_curdestdir)/usr/share/locale/$$i/LC_MESSAGES/; \
	  msgfmt $$y -o $(cdbs_curdestdir)/usr/share/locale/$$i/LC_MESSAGES/squeak.mo --statistics ; \
	done

binary-post-install/$(pkg)::
	rm -f $(cdbs_curdestdir)/usr/bin/squeak.sh
	mv $(cdbs_curdestdir)/usr/lib/squeak/- $(cdbs_curdestdir)/usr/lib/squeak/$(DEB_VERSION_UPSTREAM)

binary-strip/$(pkg)::
	$(if $(filter nostrip,$(DEB_BUILD_OPTIONS)),,strip -s --remove-section=.comment $(cdbs_curdestdir)/usr/lib/squeak/*/*)

=== debian/watch ===
# Run the "uscan" command to check for upstream updates and more.
version=3
http://www.squeakvm.org/unix/ release/Squeak-(\d[\d\.]+)-src\.tar\.gz

## squeak-vm 4.10.2.2614%2B20120917~dfsg

=== platforms/unix/plugins/SqueakFFIPrims/Makefile ===
### This Makefile is NOT used to build Squeak.
### 
### See the file `00README' for instructions.
### 
### Last edited: 2003-01-30 00:02:00 by piumarta on emilia.inria.fr

CPU=	$(shell ./ffi-config -cpu)
ABI=	$(shell ./ffi-config -abi)
LIB=	$(shell ./ffi-config -lib)

INC=	-I../../../Cross/plugins/SqueakFFIPrims
DEF=	-DFFI_TEST

CFLAGS=	-g -Wall -Wno-unused -O2 $(DEF) $(INC)

OBJ=	ffi-test-main.o ffi-test.o $(CPU)-$(ABI).o $(CPU)-$(ABI)-asm.o

main : sq.h $(OBJ)
	gcc -g -o $@ $(OBJ) $(LIB)

libffi :
	$(MAKE) CPU=any ABI=libffi LIB=-lffi

sq.h :
	ln -s ffi-test-sq.h sq.h

%.o : Makefile

clean :
	/bin/rm -f *~ *.o main sq.h
